package de.intevation.artifactdatabase.rest;

import de.intevation.artifacts.ArtifactDatabase;

import org.restlet.data.MediaType;

import org.restlet.resource.Get;  
import org.restlet.resource.ServerResource;

import org.restlet.ext.xml.DomRepresentation;

import org.restlet.representation.Representation;

import de.intevation.artifactdatabase.XMLUtils;
import de.intevation.artifactdatabase.XMLUtils.ElementCreator;

import de.intevation.artifactdatabase.DefaultArtifact;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.apache.log4j.Logger;

/**
 * @author Sascha L. Teichmann (sascha.teichmann@intevation)
 */
public class FactoriesResource
extends      ServerResource
{
    private static Logger logger = Logger.getLogger(FactoriesResource.class);
    
    public static final String PATH = "/factories";

    @Get
    public Representation represent() {

        Document document = XMLUtils.newDocument();

        ElementCreator ec = new ElementCreator(
            document,
            DefaultArtifact.NAMESPACE_URI,
            DefaultArtifact.NAMESPACE_PREFIX);

        ArtifactDatabase db = (ArtifactDatabase)getContext()
            .getAttributes().get("database");

        Element root = ec.create("result");
        document.appendChild(root);

        Element type = ec.create("type");
        ec.addAttr(type, "name", "factory-list");
        root.appendChild(type);

        Element factories = ec.create("factories");
        root.appendChild(factories);

        String [] factoryNames = db.getArtifactFactoryNames();

        for (int i = 0; i < factoryNames.length; ++i) {
            Element factoryElement = ec.create("factory");
            ec.addAttr(factoryElement, "name", factoryNames[i]);
            factories.appendChild(factoryElement);
        }

        return new DomRepresentation(
            MediaType.APPLICATION_XML, document);
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8:
